/*
 * OpenDSA Project Distributed under the MIT License
 * 
 * Copyright (c) 2011-2016 - Ville Karavirta and Cliff Shaffer
 */

/**
 * Insertion sorter.
 *
 */
public class InsertionSorter<T extends Comparable<T>> extends Sorter<T> {

  /**
   * Insertion sort the array.
   */
  @Override
  public void sort(T[] items) {

    for (int i = 1; i < items.length; i++) { // Insert i'th record
      for (int j = i; (j > 0) && (items[j].compareTo(items[j - 1]) < 0); j--) {
        swap(items, j, j - 1);
      }
    }
  }

  public String toString() {
    return "InsertionSort";
  }

}
