import java.util.Random;

/**
 * Random sequence generator for testing sort algorithms.
 * 
 * @author Nathan Sprague
 * @version 10/2016
 *
 */
public class RandomGenerator extends Generator {

  private Random gen;

  /**
   * Create a random sequence generator.
   */
  public RandomGenerator() {
    gen = new Random();
  }

  /**
   * Generate a random sequence of Integers with the indicated size. The entries
   * in the resulting sequence will be drawn from all possible integers with
   * equal probability.
   */
  @Override
  public Integer[] generate(int size) {
    Integer[] result = new Integer[size];

    for (int i = 0; i < size; i++) {
      result[i] = new Integer(gen.nextInt());
    }
    return result;


  }

}
