/*
 * OpenDSA Project Distributed under the MIT License
 * 
 * Copyright (c) 2011-2016 - Ville Karavirta and Cliff Shaffer
 */

/**
 * Selection sort class.
 */
public class SelectionSorter<T extends Comparable<T>> extends Sorter<T> {

  /**
   * Selection sort the provided array.
   */
  @Override
  public void sort(T[] items) {

    for (int i = 0; i < items.length - 1; i++) { // Select i'th biggest record
      int bigindex = 0; // Current biggest index
      for (int j = 1; j < items.length - i; j++) { // Find the max value
        if (items[j].compareTo(items[bigindex]) > 0) { // Found something bigger
          bigindex = j; // Remember bigger index
        }
      }
      swap(items, bigindex, items.length - i - 1); // Put it into place
    }
  }

  public String toString() {
    return "SelectionSort";
  }

}
