/**
 * Abstract sorting class. Concrete classes must override the sort method.
 * 
 * @author Nathan Sprague
 * @version 10/2016
 */
public abstract class Sorter<T extends Comparable<T>> {

  /**
   * Sort the provided array of items.
   */
  public abstract void sort(T[] items);

  /**
   * Swap items i and j in the provided array.
   */
  public void swap(T[] items, int i, int j) {
    T tmp = items[i];
    items[i] = items[j];
    items[j] = tmp;
  }
}
